--------------------------------------------------------------------------------
-- Dropdownmenu                                                               --
--------------------------------------------------------------------------------
local _, me = ...                                 --Includes all functions and variables

function me:UpdateMenu(level, value)
	local info = {}
	if not level then return end
	--<<LEVEL 1>>--
	if level == 1 then
		if me:tcount(me:GetProfs(true))>0 then
			for name,v in me:pairsByKeys(me:GetProfs(true)) do
				local title=true
				for subname,icon in pairs(v) do
					if me:GetSave("filter",subname)~=true then
						if title then
							me.dewdrop:AddLine('isTitle',true,'text',name)
							title=nil
						end
						me.dewdrop:AddLine('text',subname,'icon',icon,'secure',{type1='spell',spell=subname},'tooltipFunc',function() return end,'closeWhenClicked',true)
					end
				end
			end
		end
		if me:tcount(me.quicktradeskills)>0 then
			local first=true
			for k,v in me:pairsByKeys(me.quicktradeskills) do
				if me:GetProfs()[v.name] then
					if first then me.dewdrop:AddLine() end
					first=nil
					me.dewdrop:AddLine('hasArrow',true,'text',"|cffff0000"..v.name.."|r",'icon',v.icon,'value',k,'tooltipFunc',function() return end)
				end
			end
		end
		me.dewdrop:AddLine()                           --list other chars
		me.dewdrop:AddLine('hasArrow',true,'text',"|cff00ff00"..me.L["otherchar"].."|r",'value',"tradelinks",'tooltipFunc',function() return end)
		me.dewdrop:AddLine()
		me.dewdrop:AddLine('hasArrow',true,'text',me.L["settings"],'value',"config",'tooltipFunc',function() return end)
	--<<LEVEL 2>>--
	elseif level == 2 then
		--Settingsmenu
		if value == "config" then
			me.dewdrop:AddLine('hasArrow',true,'text',me.L["quicklaunch"],'value',"quicklaunch",'tooltipFunc',function() return end)
			me.dewdrop:AddLine('hasArrow',true,'text',me.L["quicklauncher"],'value',"quicklauncher",'tooltipFunc',function() return end)
			me.dewdrop:AddLine()
			me.dewdrop:AddLine('hasArrow',true,'text',me.L["tooltips"],'value',"tooltip",'tooltipFunc',function() return end)
			me.dewdrop:AddLine('hasArrow',true,'text',me.L["filter"],'value',"filter",'tooltipFunc',function() return end)
			info.func = function()
				if me:GetSave("trainerdisabled") then
					me.Trainer.showbtn:Show()
					me:SetSave(false,"trainerdisabled")
				else
					me.Trainer.showbtn:Hide()
					me.Trainer.showframe = nil
					me:Trainer_Refresh()
					me:SetSave(true,"trainerdisabled")
				end
			end
			if me:GetSave("trainerdisabled") then info.checked=true else info.checked=nil end
			me.dewdrop:AddLine('text',me.L.trainerdisabled,'func',info.func,'checked',info.checked,'tooltipFunc',function() return end)
			--Both Factions
			info.func = function()
				if me:GetSave("bothfactions") then
					me:SetSave(false,"bothfactions")
				else
					me:SetSave(true,"bothfactions")
				end
			end
			if me:GetSave("bothfactions") then info.checked=true else info.checked=nil end
			me.dewdrop:AddLine('text',me.L["bothfactions"],'func',info.func,'checked',info.checked,'tooltipFunc',function() return end)
			--Mouse Buttons Exchange
			info.func = function()
				if me:GetSave("config","exchangeleftright") then
					me:SetSave(false,"config","exchangeleftright")
				else
					me:SetSave(true,"config","exchangeleftright")
				end
			end
 			if me:GetSave("config","exchangeleftright") then info.checked=true else info.checked=nil end
			me.dewdrop:AddLine('text',me.L["exchangeleftright"],'func',info.func,'checked',info.checked,'tooltipFunc',function() return end)
			--Reset CDs
			info.func = function()
				me:SetSave({},"cds")
				for k,_ in pairs(me.save) do
					if me:GetSave("faction",nil,k)==UnitFactionGroup("player") then
						me:SetSave({},"cds",nil,k)
					end
 				end 
				me.secureframe:Hide()
				GameTooltip:Hide()
				me.dewdrop:Close(1)
			end
			me.dewdrop:AddLine('text',me.L["resetcds"],'func',info.func,'tooltipFunc',function() return end)
			me.dewdrop:AddLine()
			me.dewdrop:AddLine('isTitle',true,'text',me.version)
		--list other chars
		elseif value == "tradelinks" then
			if me:GetSave("bothfactions") or UnitFactionGroup("player")=="Alliance" then
				local first=true
				for k,v in me:pairsByKeys(me.save) do
					if k~=UnitName("player") and v.faction=="Alliance" and me:GetSave("tradelinks",nil,k)~=nil and me:tcount(me:GetSave("tradelinks",nil,k))>0  then
						if first and me:GetSave("bothfactions") then
							first=nil
							me.dewdrop:AddLine('isTitle',true,'text',FACTION_ALLIANCE)
						end
						me.dewdrop:AddLine('hasArrow',true,'text',k,'value',k,'tooltipFunc',function() return end)
					end
				end
			end
			if me:GetSave("bothfactions") or UnitFactionGroup("player")=="Horde" then
				local first=true
				for k,v in me:pairsByKeys(me.save) do
					if k~=UnitName("player") and v.faction=="Horde" and me:GetSave("tradelinks",nil,k)~=nil and me:tcount(me:GetSave("tradelinks",nil,k))>0  then
						if first and me:GetSave("bothfactions") then
							first=nil
							me.dewdrop:AddLine()
							me.dewdrop:AddLine('isTitle',true,'text',FACTION_HORDE)
						end
						me.dewdrop:AddLine('hasArrow',true,'text',k,'value',k,'tooltipFunc',function() return end)
					end
				end
			end
		--Special
		else
			if me.quicktradeskills[value] then
			for _,v in me:pairsByKeys(me.quicktradeskills[value]['func']()) do
				me.dewdrop:AddLine('text',v.name,'icon',v.icon,'func',v.func,'secure',v.action,'tooltipFunc',function(self) v.tooltip(self) end)
			end
		end
	end
	--<<LEVEL 3>>--
	elseif level == 3 then
		--default professions
		if value == "quicklaunch" then
			local button="leftclick"
			if me:GetSave("config","exchangeleftright") then button="rightclick" end
			me.dewdrop:AddLine('hasArrow',true,'text',me.L[button],'value',"left",'tooltipFunc',function() return end)
			me.dewdrop:AddLine('hasArrow',true,'text',me.L["shift"].." + "..me.L[button],'value',"shiftleft",'tooltipFunc',function() return end)
			me.dewdrop:AddLine('hasArrow',true,'text',me.L["alt"].." + "..me.L[button],'value',"altleft",'tooltipFunc',function() return end)
			me.dewdrop:AddLine('hasArrow',true,'text',me.L["ctrl"].." + "..me.L[button],'value',"ctrlleft",'tooltipFunc',function() return end)
		--quicklauncher
		elseif value == "quicklauncher" then
			me.dewdrop:AddLine('hasArrow',true,'text',CREATE,'value',"newlauncher",'tooltipFunc',function() return end)
			me.dewdrop:AddLine('hasArrow',true,'text',DELETE,'value',"deletelauncher",'tooltipFunc',function() return end)
		--[[elseif value == "favorites" then
			for k,_ in pairs(me:GetProfs()) do
				me.dewdrop:AddLine('hasArrow',true,'text',k,'icon',v,'value',"favorites_"..k,'tooltipFunc',function() return end)
			end]]
		--Tooltips
		elseif value == "tooltip" then
			if (me:GetSave("ShowAllTooltips") == true) then info.checked = true else info.checked = nil end
			info.func = function()
				if (me:GetSave("ShowAllTooltips") == true) then
					me:SetSave(false,"ShowAllTooltips")
				else
					me:SetSave(true,"ShowAllTooltips")
				end
			end
			me.dewdrop:AddLine('text',me.L["ShowAllTooltips"],'func',info.func,'checked',info.checked,'tooltipFunc',function() return end)
			me.dewdrop:AddLine()
			if (me:GetSave("tooltip","showskills") == true) then info.checked = true else info.checked = nil end
			info.func = function()
				if (me:GetSave("tooltip","showskills") == true) then
					me:SetSave(false,"tooltip","showskills")
				else
					me:SetSave(true,"tooltip","showskills")
				end
			end
			me.dewdrop:AddLine('text',me.L["professions"],'func',info.func,'checked',info.checked,'tooltipFunc',function() return end)
			if (me:GetSave("tooltip","showcds") == true) then info.checked = true else info.checked = nil end
			info.func = function()
				if (me:GetSave("tooltip","showcds") == true) then
					me:SetSave(false,"tooltip","showcds")
				else
					me:SetSave(true,"tooltip","showcds")
				end
			end
			me.dewdrop:AddLine('text',me.L["showcds"],'func',info.func,'checked',info.checked,'tooltipFunc',function() return end)
			if (me:GetSave("tooltip","showbuttons") == true) then info.checked = true else info.checked = nil end
			info.func = function()
				if (me:GetSave("tooltip","showbuttons") == true) then
					me:SetSave(false,"tooltip","showbuttons")
				else
					me:SetSave(true,"tooltip","showbuttons")
				end
			end
			me.dewdrop:AddLine('text',me.L["showbuttons"],'func',info.func,'checked',info.checked,'tooltipFunc',function() return end)
		--hide professions
		elseif value == "filter" then
			for k,_ in me:pairsByKeys(me:GetProfs()) do
				info.func = function()
					if me:GetSave("filter",k)==true then
						me:SetSave(nil,"filter",k)
					else
						me:SetSave(true,"filter",k)
					end
				end
				if me:GetSave("filter",k)==true then info.checked = true else info.checked = nil end
				me.dewdrop:AddLine('text',k,'func',info.func,'checked',info.checked,'tooltipFunc',function() return end)
			end
		--list trades from an other char
		else
			for k,v in me:pairsByKeys(me:GetSave("tradelinks",nil,value)) do
				info.func = function()
					if IsShiftKeyDown() then
						if (not ChatEdit_InsertLink(v) ) then
							ChatFrame1EditBox:Show();
							ChatEdit_InsertLink(v);
						end
					else
						print("|cff00ff00Broker ProfessionsMenu: "..value..": |r"..v)
					end
				end
				info.tooltipFunc = function()
					local skill,maxskill = strmatch(v,"|Htrade:%d+:(%d+):(%d+):")
					local frame = GameTooltip:GetOwner()
					GameTooltip:SetOwner(frame, "ANCHOR_NONE")
					GameTooltip:SetPoint(me:GetTipAnchor2(frame))
					GameTooltip:ClearLines()
					GameTooltip:AddLine(value,0,1,0)
					GameTooltip:AddDoubleLine(GetSpellInfo(k),skill.."/"..maxskill,1,1,0,0,1,0)
					GameTooltip:AddLine(" ")
					GameTooltip:AddLine(me.L["leftclick"]..": |cffffffff"..me.L["linktome"].."|r")
					GameTooltip:AddLine(me.L["shift"].." + "..me.L["leftclick"]..": |cffffffff"..me.L["linktoother"].."|r")
				end
				me.dewdrop:AddLine('text',GetSpellInfo(k),'func',info.func,'tooltipFunc',info.tooltipFunc)
			end
			me.dewdrop:AddLine()
			info.tooltipFunc = function()
				local frame = GameTooltip:GetOwner()
				GameTooltip:SetOwner(frame, "ANCHOR_NONE")
				GameTooltip:SetPoint(me:GetTipAnchor2(frame))
				GameTooltip:ClearLines()
				GameTooltip:AddLine(me.L["deletechartooltip"])
			end
			me.dewdrop:AddLine('text',DELETE,'func',function() me:SetSave(nil,nil,nil,value) end,'tooltipFunc',info.tooltipFunc,'closeWhenClicked',true)
		end
	--<<LEVEL 4>>--
	elseif level == 4 then
		--New Launcher
		if value == "newlauncher" then
			for k,v in me:pairsByKeys(me:GetProfs()) do
				if not me.quicklauncher[me:GetSpellID(k)] then
					me.dewdrop:AddLine('text',k,'icon',v,'func',function() me:SetSave(true,"quicklauncher",me:GetSpellID(k)); me.quicklauncher[me:GetSpellID(k)]=me:newlauncher(k,v) end,'tooltipFunc',function() return end)
				end
			end
		--Delete Launcher
		elseif value == "deletelauncher" then
			for k,_ in me:pairsByKeys(me:GetSave("quicklauncher")) do
				me.dewdrop:AddLine('text',select(1,GetSpellInfo(k)),'icon',select(3,GetSpellInfo(k)),'func',function() me:SetSave(nil,"quicklauncher",k); me:Error(me.L["relog"]) end,'tooltipFunc',function() return end)
			end
		--[[elseif strsub(value,1,10) == "favorites_" then
			print(strsub(value,11))]]
		--Default Profession Menu
		else
			if (me:GetSave("quicklaunch",value) == 0) then info.checked = true else info.checked = nil end
			info.func = function()
				me:SetSave(0,"quicklaunch",value)
				if value=="left" then
					me:Professions_UpdateInfo(me:GetSpellInfo(me:GetSave("quicklaunch",value)))
				end
			end
			me.dewdrop:AddLine('text',"---",'func',info.func,'checked',info.checked,'tooltipFunc',function() return end)	
			me.dewdrop:AddLine()
			for k,_ in me:pairsByKeys(me:GetProfs()) do
				info.func = function()
					me:SetSave(me:GetSpellID(k),"quicklaunch",value)
					if value=="left" then
						me:Professions_UpdateInfo(me:GetSpellInfo(me:GetSave("quicklaunch",value)))
					end
				end
				local spell,_ = GetSpellInfo(me:GetSave("quicklaunch",value))
				if spell == GetSpellInfo(k) then info.checked = true else info.checked = nil end
				me.dewdrop:AddLine('text',k,'func',info.func,'checked',info.checked,'tooltipFunc',function() return end)
			end
		end --else
	end
--<<END LEVEL>>--
end --function()



function me:ShowFavorites()
	local first=true
	for profid,v in pairs(me:GetSave("favorites")) do
		local prof,_ = GetSpellInfo(profid)
		if not first then me.dewdrop:AddLine() end
		first=nil
		me.dewdrop:AddLine('isTitle',true,'text',prof)
		local table = {}
		for recipeid,type in pairs(v) do
			local name,_,icon =GetSpellInfo(recipeid)
			table[name] = {
				id = recipeid,
				icon = icon,
				type = type,
				tooltip=function()
					local frame = GameTooltip:GetOwner()
					GameTooltip:SetOwner(frame, "ANCHOR_NONE")
					GameTooltip:SetPoint(me:GetTipAnchor2(frame))
					GameTooltip:ClearLines()
					GameTooltip:SetHyperlink("|cffffffff|Henchant:"..tostring(recipeid).."|h["..name.."]|h|r")
					GameTooltip:AddLine(' ')
					--Cooldowns
					local duration=me:GetSave("cds",name)
					if me.P.SharedCDs[recipeid] then
						duration=me:GetSave("cds",me.P.SharedCDs[recipeid])
					end
					if duration then
						duration = difftime(duration,time())
						if duration > 0 then
							GameTooltip:AddDoubleLine(COOLDOWN_REMAINING,SecondsToTime(duration),1,0,0,1,0,0)
							GameTooltip:AddLine(' ')
						end
					end
					if type=="Create" then
						GameTooltip:AddDoubleLine(me.L["leftclick"],"|cffffffff"..CREATE.."|r")
						GameTooltip:AddDoubleLine(me.L["shift"].." + "..me.L["leftclick"],"|cffffffff"..CREATE_ALL.."|r")
					else
						GameTooltip:AddDoubleLine(me.L["leftclick"],"|cffffffff"..type.."|r")
					end
					GameTooltip:AddDoubleLine(me.L["alt"].." + "..me.L["leftclick"],"|cffffffff"..DELETE.."|r")
				end,
			}
		end
		for kk,vv in me:pairsByKeys(table) do
			local func = function()
				if IsAltKeyDown() then --Delete Favorite
					local data = me:GetSave("favorites",profid)
					data[vv.id] = nil
					if me:tcount(data) == 0 then
						data = nil
					end
					me:SetSave(data,"favorites",profid)
					print(format(me.L.deletedfromfavorite,GetSpellLink(vv.id)))
				else --Craft Item
					CloseTradeSkill()
					CastSpellByName(prof)
					for i=1, GetNumTradeSkills() do
						local skillname,skilltype,numAvailable,isExpanded,_ = GetTradeSkillInfo(i)
						if skilltype=='header' and not isExpanded then
							ExpandTradeSkillSubClass(i)
						elseif skillname==kk then
							local num = 1
							if IsShiftKeyDown() and vv.type=="Create" then
								num = numAvailable
							end
							TradeSkillFrame_SetSelection(i)
							TradeSkillFrame_Update()
							TradeSkillInputBox:SetNumber(num)
							DoTradeSkill(i, num)
							TradeSkillInputBox:ClearFocus()
							me.dewdrop:Open(me.dewdrop.parent, 'children', function() me:ShowFavorites() end)--Reopen Dropdownmenu
							break
						end
					end
				end
			end
			me.dewdrop:AddLine('text',kk,'icon',vv.icon,'func',func,'tooltipFunc',vv.tooltip)
		end
	end
	if first then me.dewdrop:AddLine('isTitle',true,'text',me.L.nofavorites) end
end